#!/usr/bin/perl -w

sub parse_form() {
  # POST oder GET?
  if ($ENV{'REQUEST_METHOD'} &&
      $ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  } else {
    $buffer=$ENV{'QUERY_STRING'};
  }

  # Name/Wert-Paare aufsplitten
  @pairs = split(/&/, $buffer);

  foreach $pair (@pairs) {
    # Name und Wert trennen
    ($name, $value) = split(/=/, $pair);
    # + nach Leerzeichen konvertieren
    $value =~ tr/+/ /;
    # %-Kodierung rueckgaengig machen
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack(C, hex($1))/eg;

    $FORM{$name} = $value;
  }
}

sub print_values() {
  # Diese Namen besitzen die Inputfelder im Eingabeformular
  @input_names=(Name, Beruf, URL);

  print << 'EOT';
Content-Type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
  <HEAD>
    <TITLE>CGI-Programme in C</TITLE>
  </HEAD>

  <BODY>
    <H1>CGI-Programme in C / Ergebnis der Perl-Auswertung</H1>
    <H2>&copy; Heise Verlag, Hannover</H2>
   
    <H3>Perl hat die folgenden Name/Wert-Paare identifiziert:</H3>
    <OL>
EOT

  foreach $name (@input_names) {
    print "      <LI> <CODE>$name = $FORM{$name}</CODE>\n";
  }

  print "    </OL>\n";
  print "Zugriffsmethode: $ENV{'REQUEST_METHOD'}\n";

  print << 'EOT';
  </BODY>
</HTML>
EOT
}

&parse_form();
&print_values();

